; SzCmp vs. lstrcmp speed test by Mark Jones (gzscuqn02ATsneakemailD0Tcom)

Include SzCmp.inc

.data
align 16
String1     DB  "Hello, this is an example of a MASM32 64-byte string comparison.",0
String2     DB  "Hello, this is an example of a MASM32 64-byte string comparison!",0
String3     DB  "hello, this is an example of a MASM32 64-byte string comparison.",0
LOOP_COUNT  EQU 5000000             ; 5M iterations per timing result
SzCmp1      DB  " SzCmp, 64 bytes identical string: ",0
SzCmp2      DB  " SzCmp, 64 bytes different string (last character): ",0
SzCmp3      DB  " SzCmp, 64 bytes different string (first character): ",0
lstrcmp1    DB  " lstrcmp, 64 bytes identical string: ",0
lstrcmp2    DB  " lstrcmp, 64 bytes different string (last character): ",0
lstrcmp3    DB  " lstrcmp, 64 bytes different string (first character): ",0

.code

Start:
  Invoke Main
  Invoke ExitProcess,0

Main Proc
    print chr$(" SzCmp/lstrcmp speed comparison by Mark Jones (gzscuqn02ATsneakemailD0Tcom)",13,10)
    print chr$(" Timing routines by MichaelW from MASM32 forums: http://www.masmforum.com/",13,10)
    mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    
    print chr$(13,10," These are the three 64-byte strings being tested: ",13,10," ",34)
    print addr String1
    print chr$(34,13,10," ",34)
    print addr String2
    print chr$(34,13,10," ",34)
    print addr String3
    print chr$(34,13,10,13,10," Timing results:",13,10,13,10)

    print addr SzCmp1
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCmp, addr String1, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    
    print addr SzCmp2
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCmp, addr String1, addr String2
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)

    print addr SzCmp3
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCmp, addr String1, addr String3
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10,13,10)


    print addr lstrcmp1
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke lstrcmp, addr String1, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)

    print addr lstrcmp2
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke lstrcmp, addr String1, addr String2
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)

    print addr lstrcmp3
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke lstrcmp, addr String1, addr String3
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    
    mov   eax, input(13,10," Press ENTER to exit...")
    exit ; ret also works
Main EndP

SzCmp   proc    sz1:DWORD, sz2:DWORD
    mov esi, sz1            ; load string offsets
    mov edi, sz2
    cld                     ; clear direction flag
@@:    
    cmpsb                   ; compare bytes esi,edi
    jne err                 ; different?
    cmp byte ptr [esi-1], 00  ; is one a null?   
    jz eos                  ; yes, strings match
    jmp @B
err:
    mov eax,1               ; compare failed
    ret
eos:
    mov eax,0               ; compare succeeded
    ret    
SzCmp endp

End Start
